$('#tutorial').on('click', function () {
    $(document).ready(async function () {
        const driver = new Driver({
            doneBtnText: 'Sair',
            closeBtnText: 'Fechar',
            nextBtnText: 'Próximo',
            prevBtnText: 'Anterior',
            allowClose: false
        });
        driver.defineSteps([

            {
                element: '#btnFiltros',
                popover: {
                    title: 'Botão Filtros',
                    description: 'Clique aqui para filtrar a consulta.',
                    position: 'right'
                }
            },
            {
                element: '#btnNovaMaquinaCartao',
                popover: {
                    title: 'Botão Incluir',
                    description: 'Clique aqui para iniciar o cadastro de uma máquina de cartão.',
                    position: 'right'
                }
            },
            {
                element: '#tabelaMaquinaCartao',
                popover: {
                    title: 'Tabela Regras',
                    description: 'Aqui estão os dados das máquinas cadastradas.',
                    position: 'top'
                }
            }
        ]);
        driver.start();
    });
});
$(document).ready(async function () {   
    const permissaoUsuarioLogado = await permissaoAcessos("MAQUINACARTAO");

    // autocompleta
    $('#txtMaquinaConsulta').autocompleta(1, `JSON={ "tabela":"maquina_cartao", "camposSelect":[ "nrserie chave", "descricao descricao"], "where": null}`);
    // pesquisa
    $('#btn-Maquina').pesquisa('#txtMaquinaConsulta', 'NRSERIE', 'DESCRICAO', `/sisplan/funcoes/v1/pesquisa?JSON={ "tabela":"maquina_cartao", "camposSelect":[ "nrserie", "descricao"]}`, 'Pesquisa Máquina Cartão', 'maquina_cartao');
    // limpacampo
    $('#btn-limpa-Maquina').on('click', function () {
        $('#txtMaquinaConsulta').val('');
    });

    $('#btnFiltros').on('click', function () {
        $('#modal-filtros').modal('show');
    });

    $('#btnNovaMaquinaCartao').on('click', function () {
        if (permissaoUsuarioLogado.INCLUI == 'S') {
            window.location.href = "maquinacartao/create";
        } else {
            msgAlertaSemConfirmacao("Sem permissão para incluir!");
        }
    });

    function retornaBotaoOpcoes(data) {
        var retorno = '<div style="text-align:start;"> ' +
          '    <button class="btn btn-info btn-sm dropdown-toggle btnVerificaOpcoes" type="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false"> ' +
          '      ' + data + ' ' +
          '    </button> ' +
          '    <div class="dropdown-menu"> ' +
          '    <button class="dropdown-item" type="button" title="Editar" id="btn-editar">Editar</button>     ' +
          '    <button class="dropdown-item" type="button" title="Excluir" id="btn-excluir">Excluir</button>  ' +
          '</div>';
        return retorno;
      };

    consultaRegra();

    $('#btnConsultar').on('click', async function () {
        $('#modal-filtros').modal('hide');
        await consultaRegra(true);
    });

    $('#btnLimparFiltros').on('click', async function () {
        $('#txtMaquinaConsulta').val('');
    });

    async function consultaRegra(bBotao = false) {
        try {
            $.LoadingOverlay("show");
            let response;
            let nrserie = pegaChave('#txtMaquinaConsulta') != '' ? ` AND NRSERIE = '${pegaChave('#txtMaquinaConsulta')}'` : '';
            if (bBotao) {
                response = await requisicao('GET', '/Sisplan/Funcoes/V1/pesquisa?', `JSON={ "tabela":"MAQUINA_CARTAO", "camposSelect":[ "nrserie", "descricao"], "where": ["1=1 ${nrserie}"]}`, null);
            } else {
                response = await requisicao('GET', '/Sisplan/Funcoes/V1/pesquisa?', 'JSON={ "tabela":"MAQUINA_CARTAO", "camposSelect":[ "nrserie", "descricao"], "where": null}', null);
            }

            if (!response) {
                $.LoadingOverlay("hide");
                return;
            }

            let jsonStr = await response.json();
            if (response.status != 200) {
                $.LoadingOverlay("hide");
                msgErro(jsonStr.RESULT[0].mensagem);
                return;
            }

            $('#tabelaMaquinaCartao').DataTable({
                destroy: true,
                lengthChange: false,
                serverside: true,

                "autoWidth": true,
                "data": jsonStr.RESULT[0],
                "columns": [{
                    "data": "NRSERIE"
                },
                {
                    "data": "DESCRICAO"
                },
                ],
                "columnDefs": [{
                    targets: [0], render: function (data, type, row) {
                        return retornaBotaoOpcoes(data);
                      }
                }]
            });

            $.LoadingOverlay("hide");
        } catch (error) {
            console.error(error);
            $.LoadingOverlay("hide");
        }

    }

    $('#tabelaMaquinaCartao').on('click', '#btn-editar', async function () {
        if (permissaoUsuarioLogado.ALTERA == 'S') {
        let data = $('#tabelaMaquinaCartao').DataTable().row($(this).parents('tr')).data();
        window.location.href = `maquinacartao/${data.NRSERIE}`;
        } else {
            msgAlertaSemConfirmacao("Sem permissão para alterar!");
        }
    });

    $('#tabelaMaquinaCartao').on('dblclick', 'tr', async function () {
        if (permissaoUsuarioLogado.ALTERA == 'S') {
        let data = $('#tabelaMaquinaCartao').DataTable().row($(this)).data();
        window.location.href = `maquinacartao/${data.NRSERIE}`;
        } else {
            msgAlertaSemConfirmacao("Sem permissão para alterar!");
        }
    });

    $('#tabelaMaquinaCartao').on('click', '#btn-excluir', async function () {
        if (permissaoUsuarioLogado.EXCLUI == 'S') {
            msgAlerta('Você realmente deseja excluir esse registro?', async () => {
                const data = $("#tabelaMaquinaCartao").DataTable().row($(this).parents("tr"));
                await excluiRegistro(data);
            });
        } else {
            msgAlertaSemConfirmacao("Sem permissão para excluir!");
        }
    });

    async function excluiRegistro(data) {
        try {
            $.LoadingOverlay("show");
            try {
                let valorLinha = data.data();
                let response = await requisicao("DELETE", "/Sisplan/Cadastros/v1/maquinacartao?", `NRSERIE=${encodeURIComponent(valorLinha.NRSERIE)}`, null);
                if (!response) {
                    return;
                }
                if (response.status != 200) {
                    let jsonStr = await response.json();
                    msgErro(jsonStr.mensagem);
                    return;
                }

                toastr.success("Exclusão efetuada com sucesso!", "Confirmação", {
                    toastClass: "success",
                    iconClasses: {
                        error: "alert-error",
                        info: "alert-info",
                        success: "alert-success",
                        warning: "alert-warning",
                    },
                    positionClass: "toast-top-center",
                    progressBar: true,
                    timeOut: 3000,
                    fadeOut: 1000,
                    onHidden() {
                        data.remove().draw(false);
                    },
                }).css({
                    "margin-top": "20%",
                    width: "500px",
                    "max-width": "500px",
                });

            } catch (error) {
                console.error(error);
            }
        } finally {
            $.LoadingOverlay("hide");
        }
    }
});